import { Ref } from 'vue';
import { IStyles, Options, IResizeBoundingClassNames, PaneDirections } from '../shared/typings';

export interface Props {
    prefix: string;
    direction: PaneDirections;
    options: Options;
    classNames: IResizeBoundingClassNames;
    styles?: Partial<IStyles>;
}
export declare enum Emits {
    FOCUS = "focus",
    DRAG_START = "drag:start",
    DRAG_MOVE = "drag:move",
    DRAG_END = "drag:end"
}
export interface PaneEmittedData {
    x: number;
    y: number;
    dir: PaneDirections;
}
declare const _default: __VLS_WithTemplateSlots<import('vue').DefineComponent<import('vue').ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    direction: PaneDirections;
}>>, {
    refPane: Ref<HTMLDivElement | null, HTMLDivElement | null>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    "drag:start": (data: PaneEmittedData) => void;
    "drag:move": (data: PaneEmittedData) => void;
    "drag:end": (data: PaneEmittedData) => void;
    focus: (isFocused: boolean) => void;
}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    direction: PaneDirections;
}>>> & Readonly<{
    onFocus?: ((isFocused: boolean) => any) | undefined;
    "onDrag:start"?: ((data: PaneEmittedData) => any) | undefined;
    "onDrag:move"?: ((data: PaneEmittedData) => any) | undefined;
    "onDrag:end"?: ((data: PaneEmittedData) => any) | undefined;
}>, {
    direction: PaneDirections;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>, {
    default?(_: {}): any;
}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
